package jalview.util;

import java.util.*;

/**
 * ShiftList
 * Simple way of mapping a linear series to a new linear range with new points introduced.
 * Use at your own risk!
 * <p>Title: ShiftList</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: Dundee University</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ShiftList
{
    Vector shifts;
  public ShiftList()
  {
    shifts = new Vector();
  }

  /**
   * addShift
   * @param pos start position for shift (in original reference frame)
   * @param shift length of shift
   */
  public void addShift(int pos, int shift)
  {
    int sidx = 0;
    int[] rshift=null;
    while (sidx<shifts.size() && (rshift=(int[]) shifts.get(sidx))[0]<pos)
      sidx++;
    if (sidx==shifts.size())
      shifts.insertElementAt(new int[] { pos, shift}, 0);
    else
      rshift[1]+=shift;
  }

  /**
   * shift
   *
   * @param pos int
   * @return int shifted position
   */
  public int shift(int pos)
  {
    if (shifts.size()==0)
      return pos;
    int shifted=pos;
    int sidx=0;
    int rshift[];
    while (sidx<shifts.size()
           &&
           (rshift=((int[]) shifts.get(sidx++)))[0]<=pos) {
      shifted += rshift[1];
    }
    return shifted;
  }

  /**
   * clear all shifts
   */
  public void clear()
  {
    shifts.removeAllElements();
  }

}
